#include "sk9822.h"

void send_byte(io_pin_t data_pin, io_pin_t clock_pin, uint8_t byte) {
    for (int i = 7; i >= 0; i--) {
        if (byte & _BV(i)) {
            (*data_pin.port) |= _BV(data_pin.pin);
        } else {
            (*data_pin.port) &= ~(_BV(data_pin.pin));
        }
        (*clock_pin.port) |= _BV(clock_pin.pin);
        (*clock_pin.port) &= ~(_BV(clock_pin.pin));
    }
}

void send_start(io_pin_t data_pin, io_pin_t clock_pin) {
    send_byte(data_pin, clock_pin, 0);
    send_byte(data_pin, clock_pin, 0);
    send_byte(data_pin, clock_pin, 0);
    send_byte(data_pin, clock_pin, 0);
}

void send_term(io_pin_t data_pin, io_pin_t clock_pin) {
    send_byte(data_pin, clock_pin, 0xff);
    send_byte(data_pin, clock_pin, 0xff);
    send_byte(data_pin, clock_pin, 0xff);
    send_byte(data_pin, clock_pin, 0xff);
}

void send_pixels(io_pin_t data_pin, io_pin_t clock_pin, rgb_t * pixels, uint8_t count) {
    send_start(data_pin, clock_pin);
    for (uint8_t i = 0; i < count; i++) {
        send_byte(data_pin, clock_pin, 0xe0 + pixels[i].brightness);
        send_byte(data_pin, clock_pin, pixels[i].r);
        send_byte(data_pin, clock_pin, pixels[i].b);
        send_byte(data_pin, clock_pin, pixels[i].g);
    }
    send_term(data_pin, clock_pin);
}
